
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <time.h>
#include <gl/image.h>

#include "frcmpr.h"


extern PAR_COMPR   par_cmp;
extern LIST        *lst;
extern CONTORNO    *cont;
extern BYTE        *image, *image2;
extern int         img_size_x, img_size_y;
extern int         zoom, nbox, xxx;





/************/
load_image( char *filename )	    /* SILICON GRAPHICS FILE FORMAT */
/************/
{
IMAGE		*sgi_img; 
int		x, y;
unsigned short	rbuf[4096], gbuf[4096], bbuf[4096];

    if ((sgi_img = iopen(filename, "r")) == NULL) return(0);
    if (sgi_img->zsize != 3) return(0);
    img_size_x = sgi_img->xsize; 
    img_size_y = sgi_img->ysize;
    
    image = malloc( img_size_x * img_size_y );
    for( y=0;  y<img_size_y;  y++ ) {
	getrow(sgi_img, rbuf, y, 0);
	getrow(sgi_img, gbuf ,y, 1);
	getrow(sgi_img, bbuf, y, 2);
	for( x=0;   x<img_size_x;   x++ )
	    IMG( x, y ) = GRIGIO( rbuf[x], gbuf[x], bbuf[x] );
	}
    iclose(sgi_img);
    
    image2 = malloc( img_size_x * img_size_y );
    memset( image2, 0, img_size_x * img_size_y );
}




/***********/
save_image( char *fname)	/* salva immagine presente a video... */
/***********/
{
IMAGE		*sgi_img; 
int		x, y; 
unsigned short	wbuf[4096];

    sgi_img = iopen(fname, "w", RLE(1), 3, img_size_x, img_size_y, 3); 
    if( sgi_img == NULL) return(0); 

    for (y=0;  y<img_size_y;  y++) {
       for (x=0;  x<img_size_x;  x++) 
	    wbuf[x] = IMG( x, y );
        if (putrow(sgi_img, wbuf, y, 0) == -1) return(0);
        if (putrow(sgi_img, wbuf, y, 1) == -1) return(0);
        if (putrow(sgi_img, wbuf, y, 2) == -1) return(0);
	}
    iclose(sgi_img); 
    return( 1 );
}




/************/
double   diff_image( char *s, char *t )
/************/
{
unsigned char	*tmp;
int		i, j;
double		err;

load_image( t );
tmp = malloc( img_size_x * img_size_y );
memcpy( tmp, image, img_size_x * img_size_y );

load_image( s );
memcpy( image2, tmp, img_size_x * img_size_y );
free( tmp );

/* Now "image" contains "s"   and   "image2" contains "t"... */

j = img_size_x * img_size_y;

for( err=0.0, i=0;   i < j;   i++ ) {
   err += ((image[i] - image2[i]) * (image[i] - image2[i]));
   image[i] = blimit( 128 - ( image[i] - image2[i] ) );
   }
free( image ); free( image2 );
return( err / j );
}




/************/
show_image()
/************/
{
int    x, y;

for( y=0;    y < img_size_y;    y++ )
   for( x=0;   x < img_size_x;   x++ )
       fast_show_rect( max( 0, min( 247, IMG( x, y ))), x, y );
}




/***********/
rgb_to_yiq( r, g, b, y, i, q )
/***********/
float  r, g, b;
float  *y, *i, *q;
{
   *y = (0.3*r + 0.59*g + 0.11*b);
   *i = (0.6*r - 0.28*g - 0.32*b);
   *q = (0.21*r - 0.52*g + 0.31*b);
}


/***********/
yiq_to_rgb( y, i, q, r, g, b )
/***********/
float y, i, q;
float *r, *g, *b;
{
   *r = 1.0*y + 0.948262*i + 0.624013*q;
   *g = 1.0*y - 0.276066*i - 0.63981*q;
   *b = 1.0*y - 1.10545*i + 1.72986*q;
}


