
#include <unistd.h>


typedef double * FVEC;

#define FALSE 0
#define TRUE  1

#define DRR    par_cmp.D_R_rapp
#define MIN_A  par_cmp.min_div_area

#define SET_PAR            'P'
#define SHOW_PAR           'V'
#define LOAD_PAR           'L'
#define SHOW_MAP           'E'
#define SHOW_SHAPE         'S'
#define COMPRIMI_GREY      'C'
#define DECOMPRIMI_GREY    'D'
#define SHOW_GREY_DIFF     '-'
#define QUIT               'X'


#define GREY_IMG_DIR   ""
#define GREY_MAP_DIR   ""
#define RGB_IMG_DIR    ""
#define RGB_RIG_DIR    ""
#define RGB_MAP_DIR    ""


/****************************************************/
/*
r.x1   ->  range start x   :  10 bit       per img fino a 1024x1024...
r.y1   ->    "     "   y   :  10
rx     ->    "   dim   x   :   9
ry     ->    "     "   y   :   9
d.x1   ->  dom  start  x   :  10
d.y1   ->   "      "   y   :  10
mode   ->  mode            :   2
o      ->  brightness      :  10
s      ->  contrast        :  10
------------------------------------
                        tot:  80 bit
*/

typedef struct {
   unsigned int    rsx : 9, rsy : 9,
                   rdx :  9, rdy :  9,
                   dsx : 9, dsy : 9,
                   modo : 2;
   int             brigh : 12, contr : 12;
   }
DATA_OUT;


#define    noPACK_MAP

#ifdef PACK_MAP
   #define readmap     pack_readmap
   #define writemap    pack_writemap
#else
   #define readmap     ascii_readmap
   #define writemap    ascii_writemap
#endif

#define   ascii_writemap()     fprintf( fp, "%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t%d\t\t%.3f\n",\
                               r->x1,  r->y1,  r->x2-r->x1+1,  r->y2-r->y1+1,\
                               d->x1,  d->y1,  mode,  (int )(o+0.5), (float )s );\
                               lst = del_list_head( lst );

#define    ascii_readmap()     i = fscanf( fp, "%d %d %d %d %d %d %d %lf %lf",\
                               &r.x1, &r.y1, &rx, &ry, &d.x1, &d.y1, &mode, &o, &s );\
                               if( i != 9 ) break;


#define    pack_writemap()     write_map_record( fp, r->x1,  r->y1,  r->x2-r->x1+1,  r->y2-r->y1+1,\
                               d->x1,  d->y1,  mode,  (int )(o+0.5), (int )(s*100.) );\
                               lst = del_list_head( lst );

#define    pack_readmap()      i = read_map_record( fp, &(r.x1), &(r.y1), &rx, &ry, &(d.x1), &(d.y1), &mode, &o, &s );\
                               if( i < 1 ) break;
/****************************************************/


/****************************************************/
#define    H_V         /* tipo di suddivisione: if not H_V => QUAD_TREE */
#ifdef H_V
   #define DIVIDI  sub_div_2_new
#else
   #define DIVIDI  sub_div_4
#endif
/****************************************************/


#define    MAX_AREA_RANGO  512 


#define    BIANCO  248
#define    NERO    249
#define    MAGENTA 250
#define    ROSSO   251
#define    GIALLO  252
#define    VERDE   253
#define    BLU     254
#define    CIANO   255


#define REPLACE	    LO_SRC
#define XOR	    LO_XOR

#define getch()	    getchar()
#define waitkey()   getchar()
#define min(a, b)   ((a)<(b))?(a):(b)
#define max(a, b)   ((a)>(b))?(a):(b)


typedef unsigned char BYTE;

typedef struct {
   int     x1, y1,
           x2, y2,
           x3, y3;
   }
   COORD_3P;


typedef struct {
   short   x, y;
   }
   XY;


typedef struct {
   short   xl, xr;
   }
   X1X2;


typedef struct {
   int     cnt;
   X1X2    *range;
   }
   CONTORNO;


typedef struct {
       int     x1, y1,
               x2, y2;
       }
   RECT;


typedef struct {
       RECT    vertex;
       BYTE    *data;
       }
   RECT_DATA;


typedef struct _list {
       RECT            rect;
       struct _list    *next;
       }
   LIST;


typedef struct _list_x {
       RECT            rango;
       RECT            dominio;
       double          rms;
       struct _list_x  *next;
       }
   LIST_X;


typedef struct {
       RECT        rango;
       RECT        dominio;
       double      rms, s, o;
       int         mode;
       }
   RAN_DOM;


typedef struct {
       double  
               a, b,       e,
               c, d,       f,
                     s,    o;   
       }
   C_MAP;


typedef struct {
       C_MAP   *w;
       double  *p;
       int     n;
       }
   IFS;


/*
** Parametri per la compressione...
*/
typedef struct {
   float   max_rms;        /* max RMS error */
   float   D_R_rapp;       /* ratio between domain and range => contractivity */
   float   max_contrast;   /* max contrast */
   int     min_div_area;   /* min range size */
   int     soglia;         /* threshold to select edges in the image */
   int     search_step;    /* step to search the best domain */
   int     complex;        /* coplexity factor of a box */
   }
PAR_COMPR;



#define GRIGIO(r, g, b)	(unsigned char )( 0.30*r+0.59*g+0.11*b )


#define    w(i, j)     cifs->w[i].j
#define    beep();     { putchar('\007'); fflush(stdout); }

#define    X1( i )     i->vertex.x1
#define    Y1( i )     i->vertex.y1
#define    X2( i )     i->vertex.x2
#define    Y2( i )     i->vertex.y2
#define    X_DIM( i )  (abs(X2(i) - X1(i))+1)
#define    Y_DIM( i )  (abs(Y2(i) - Y1(i))+1)
#define    A_DIM( i )  (X_DIM(i) * Y_DIM(i))

#define    a( i )      _a->data[i]
#define    b( i )      _b->data[i]

#define    libera( i )  free( i->data ); free( i )
#define    M( x, y )    m->data[ ((y) * mdim_x) + (x) ]
#define    C( x, y )    c->data[ ((y) * cdim_x) + (x) ]
#define    T( x, y )    t->data[ ((y) * tdim_x) + (x) ]
#define    A( x, y )    _a->data[ ((y) * adim_x) + (x) ]
#define    IMG( x, y )  image[ ((y) * img_size_x) + (x) ]
#define    IMG2( x, y )     image2[ ((y) * img_size_x) + (x) ]
#define    D_IMG( x, y )    D_scaled[ ((y) * D_size_x) + (x) ]

#define    plotpixel( x, y, z )    color( z ); smove( x, y ); point()

#define C_CNT( y )         cont[y].cnt
#define C_XL( y, b )       cont[y].range[b].xl
#define C_XR( y, b )       cont[y].range[b].xr
#define C_RANGE( y, b )    &cont[y].range[b]


#define    MSG1VAL( s, v1 )          printf( s, v1 ); printf("\n");
#define    MSG2VAL( s, v1,v2 )       printf( s, v1, v2 ); printf("\n");
#define    MSG3VAL( s, v1,v2,v3 )    printf( s, v1, v2, v3 ); printf("\n");
#define    MSG4VAL( s, v1,v2,v3,v4 ) printf( s, v1, v2, v3, v4 ); printf("\n");

/*
#define    ask_int( message, val )     printf(message); fflush(stdout); gets(msg_buf); val=atoi(msg_buf);
*/
#define    ask_int( message, val )     printf(message); fflush(stdout); scanf(" %d", &val);

#define    ask_str( message, str )     printf(message); fflush(stdout); gets( str );

#define   subdivide()          t = *r;\
                               lst = del_list_head( lst );\
                               DIVIDI( 0, NERO, t.x1, t.y1, t.x2, t.y2 );

#define    writeheader()       fp = fopen( outmap, "wb" ); \
                               fprintf( fp, "%d %d\n", img_size_x, img_size_y ); \
                               fprintf( fp, "%.1f %.1f %.1f %d %d %d %d\n",   par_cmp.max_rms, \
                                   par_cmp.D_R_rapp,  par_cmp.max_contrast, \
                                   par_cmp.min_div_area,  par_cmp.soglia, \
                                   par_cmp.search_step,  par_cmp.complex );
   
#define    readheader( fp )    fscanf( fp, "%d %d", &img_size_x, &img_size_y );\
                               fscanf( fp, "%f %f %f %d %d %d %d%*c",   &par_cmp.max_rms,\
                                   &par_cmp.D_R_rapp,  &par_cmp.max_contrast,\
                                   &par_cmp.min_div_area,  &par_cmp.soglia,\
                                   &par_cmp.search_step,  &par_cmp.complex );

#define    load_default_par()      fscanf( fp, "%d %d", &img_size_x, &img_size_y );\
                                   fscanf( fp, "%f %f %f %d %d %d %d%*c",   &par_cmp.max_rms,\
                                       &par_cmp.D_R_rapp,  &par_cmp.max_contrast,\
                                       &par_cmp.min_div_area,  &par_cmp.soglia,\
                                       &par_cmp.search_step,  &par_cmp.complex );

#define    rect_area( r )       ((r->x2 - r->x1 + 1) * (r->y2 - r->y1 + 1))

#define	   exist( s )		( access( s, R_OK) == 0 )
#define    validate( s )        if( ! exist( s ) ) { \
                                   printf("\n\nCannot open %s\n", s ); \
                                   beep(); waitkey();  goto start; }

#define    blimit(i)            max( 0, min( 247, i) )
/***************************************************************************** */


FVEC       compute_map( COORD_3P *, COORD_3P * );
void       free_ifs( IFS * );
IFS        *alloc_ifs( void );
char       *get_msg( short , short  );
void       find_start( int, int, int *, int * );

double     end_timer( short );
double     diff_image( char *, char * );
RECT_DATA  *alloc_rect( RECT * );
RECT_DATA  *map_mode( int, RECT_DATA * );
LIST       *add_list_head( LIST *,  RECT * );
LIST       *del_list_head( LIST * );
RECT       *get_list_head( LIST * );
RECT       *find_D_for_R( RECT *,  int *, double *, double *, double * );
double     compute_s_o_rms( RECT_DATA *, RECT_DATA *, double *, double *, int );
double     find_map_error( RECT_DATA **, RECT_DATA *, int *, double *, double * );


